  ; ===========================================
  ; Name:       fhcrt.dll
  ;
  ; Author:     Fallenhobbit
  ;
  ; Purpose:    wrapper library for msvcrt.dll
  ; It wraps the _cdecl c/c++ runtime
  ; in an stdcall layer. This means you
  ; can call the functions using invoke
  ; from Masm32. Notice the functions use the 
  ; normal name with 'fh_' prepended to
  ; them. I do this so if you want to call the
  ; _cdecl version directly you can. This is by no means ALL
  ; of the functions exported in msvcrt.dll. See msvcrtundoc.inc
  ; for the exports not in this library. This is all the ones
  ; that most c/c++ implementations have. 
  ;
  ; Warning: printf, scanf, and their variants
  ; have a slightly modified calling method.
  ; In order to make them stdcall, I had to limit
  ; the maximum number of parameters. I limited 
  ; them to 6. If you have less than 6, pass 0 
  ; for the others. vprintf and its variants
  ; work as normal (they take a va_list pointer). 
  ; See the notes at the bottom on how a va_list
  ; is defined.
  ; ===========================================
  
fh_chmod PROTO :DWORD,:DWORD
fh_close PROTO :DWORD
fh_chdir PROTO :DWORD
fh_chdrive PROTO :DWORD
fh_getdrive PROTO
fh_creat PROTO :DWORD,:DWORD
fh_eof PROTO :DWORD
fh_lseek PROTO :DWORD,:DWORD,:DWORD
fh_mkdir PROTO :DWORD
fh_open PROTO :DWORD,:DWORD,:DWORD
fh_read PROTO :DWORD,:DWORD,:DWORD
fh_rmdir PROTO :DWORD
fh_write PROTO :DWORD,:DWORD,:DWORD
fh_itoa PROTO :DWORD,:DWORD,:DWORD
fh_itow PROTO :DWORD,:DWORD,:DWORD
fh_abort PROTO 
fh_abs PROTO :DWORD
fh_acos PROTO :QWORD
fh_asctime PROTO :DWORD
fh_asin PROTO :QWORD
fh_atan2 PROTO :QWORD,:QWORD
fh_atan PROTO :QWORD
fh_atexit PROTO :DWORD
fh_atof PROTO :DWORD
fh_atoi PROTO :DWORD
fh_atol PROTO :DWORD
fh_bsearch PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fh_calloc PROTO :DWORD,:DWORD
fh_ceil PROTO :QWORD
fh_clearerr PROTO :DWORD
fh_clock PROTO 
fh_cos PROTO :QWORD
fh_cosh PROTO :QWORD
fh_ctime PROTO :DWORD
fh_difftime PROTO :DWORD,:DWORD
fh_exit PROTO :DWORD
fh_exp PROTO :QWORD
fh_fclose PROTO :DWORD
fh_feof PROTO :DWORD
fh_ferror PROTO :DWORD
fh_fflush PROTO :DWORD
fh_fgetc PROTO :DWORD
fh_fgetpos PROTO :DWORD,:DWORD
fh_fgets PROTO :DWORD,:DWORD,:DWORD
fh_fgetwc PROTO :DWORD
fh_fgetws PROTO :DWORD,:DWORD,:DWORD
fh_floor PROTO :QWORD
fh_fmod PROTO :QWORD,:QWORD
fh_fopen PROTO :DWORD,:DWORD
fh_fputc PROTO :DWORD,:DWORD
fh_fputs PROTO :DWORD,:DWORD
fh_fputwc PROTO :WORD,:DWORD
fh_fputws PROTO :DWORD,:DWORD
fh_fread PROTO :DWORD,:DWORD,:DWORD,:DWORD
fh_free PROTO :DWORD
fh_freopen PROTO :DWORD,:DWORD,:DWORD
fh_frexp PROTO :DWORD,:DWORD,:DWORD
fh_fseek PROTO :DWORD,:DWORD,:DWORD
fh_fsetpos PROTO :DWORD,:DWORD
fh_ftell PROTO :DWORD
fh_fwrite PROTO :DWORD,:DWORD,:DWORD,:DWORD
fh_getc PROTO :DWORD
fh_getchar PROTO 
fh_getenv PROTO :DWORD
fh_gets PROTO :DWORD
fh_getwc PROTO :DWORD
fh_getwchar PROTO 
fh_gmtime PROTO :DWORD
fh_isalnum PROTO :DWORD
fh_isalpha PROTO :DWORD
fh_iscntrl PROTO :DWORD
fh_isdigit PROTO :DWORD
fh_isgraph PROTO :DWORD
fh_isleadbyte PROTO :DWORD
fh_islower PROTO :DWORD
fh_isprint PROTO :DWORD
fh_ispunct PROTO :DWORD
fh_isspace PROTO :DWORD
fh_isupper PROTO :DWORD
fh_iswalnum PROTO :DWORD
fh_iswalpha PROTO :DWORD
fh_iswascii PROTO :WORD
fh_iswcntrl PROTO :DWORD
fh_iswctype PROTO :WORD,:WORD
fh_iswdigit PROTO :WORD
fh_iswgraph PROTO :WORD
fh_iswlower PROTO :WORD
fh_iswprint PROTO :WORD
fh_iswpunct PROTO :WORD
fh_iswspace PROTO :WORD
fh_iswupper PROTO :WORD
fh_iswxdigit PROTO :WORD
fh_isxdigit PROTO :DWORD
fh_labs PROTO :DWORD
fh_ldexp PROTO :QWORD,:DWORD
fh_ldiv PROTO :DWORD,:DWORD
fh_localeconv PROTO 
fh_localtime PROTO :DWORD
fh_log10 PROTO :QWORD
fh_log PROTO :QWORD
fh_malloc PROTO :DWORD
fh_mblen PROTO :DWORD,:DWORD
fh_mbstowcs PROTO :DWORD,:DWORD,:DWORD
fh_mbtowc PROTO :DWORD,:DWORD,:DWORD
fh_memchr PROTO :DWORD,:DWORD,:DWORD
fh_memcmp PROTO :DWORD,:DWORD,:DWORD
fh_memcpy PROTO :DWORD,:DWORD,:DWORD
fh_memmove PROTO :DWORD,:DWORD,:DWORD
fh_memset PROTO :DWORD,:DWORD,:DWORD
fh_mktime PROTO :DWORD
fh_modf PROTO :QWORD,:DWORD
fh_perror PROTO :DWORD
fh_pow PROTO :QWORD,:QWORD
fh_putc PROTO :DWORD,:DWORD
fh_putchar PROTO :DWORD
fh_puts PROTO :DWORD
fh_putwc PROTO :WORD,:DWORD
fh_putwchar PROTO :WORD
fh_qsort PROTO :DWORD,:DWORD,:DWORD
fh_raise PROTO :DWORD
fh_rand PROTO 
fh_realloc PROTO :DWORD,:DWORD
fh_remove PROTO :DWORD
fh_rename PROTO :DWORD,:DWORD
fh_rewind PROTO :DWORD
fh_setbuf PROTO :DWORD,:DWORD
fh_setlocale PROTO :DWORD,:DWORD
fh_setvbuf PROTO :DWORD,:DWORD,:DWORD,:DWORD
fh_sin PROTO :QWORD
fh_sinh PROTO :QWORD
fh_sqrt PROTO :QWORD
fh_srand PROTO :DWORD
fh_strcat PROTO :DWORD,:DWORD
fh_strchr PROTO :DWORD,:DWORD
fh_strcmp PROTO :DWORD,:DWORD
fh_strcoll PROTO :DWORD,:DWORD
fh_strcpy PROTO :DWORD,:DWORD
fh_strcspn PROTO :DWORD,:DWORD
fh_strerror PROTO :DWORD
fh_strftime PROTO :DWORD,:DWORD,:DWORD,:DWORD
fh_strlen PROTO :DWORD
fh_strncat PROTO :DWORD,:DWORD,:DWORD
fh_strncmp PROTO :DWORD,:DWORD,:DWORD
fh_strncpy PROTO :DWORD,:DWORD,:DWORD
fh_strpbrk PROTO :DWORD,:DWORD
fh_strrchr PROTO :DWORD,:DWORD
fh_strspn PROTO :DWORD,:DWORD
fh_strstr PROTO :DWORD,:DWORD
fh_strtod PROTO :DWORD,:DWORD
fh_strtok PROTO :DWORD,:DWORD
fh_strtol PROTO :DWORD,:DWORD,:DWORD
fh_strtoul PROTO :DWORD,:DWORD,:DWORD
fh_strxfrm PROTO :DWORD,:DWORD,:DWORD
fh_system PROTO :DWORD
fh_tan PROTO :QWORD
fh_tanh PROTO :QWORD
fh_time PROTO :DWORD
fh_tmpfile PROTO 
fh_tmpnam PROTO :DWORD
fh_tolower PROTO :DWORD
fh_toupper PROTO :DWORD
fh_towlower PROTO :WORD
fh_towupper PROTO :WORD
fh_ungetc PROTO :DWORD,:DWORD
fh_ungetwc PROTO :WORD,:DWORD
fh_wcscat PROTO :DWORD,:DWORD
fh_wcschr PROTO :DWORD,:WORD
fh_wcscmp PROTO :DWORD,:DWORD
fh_wcscoll PROTO :DWORD,:DWORD
fh_wcscpy PROTO :DWORD,:DWORD
fh_wcscspn PROTO :DWORD,:DWORD
fh_wcsftime PROTO :DWORD,:DWORD,:DWORD,:DWORD
fh_wcslen PROTO :DWORD
fh_wcsncat PROTO :DWORD,:DWORD,:DWORD
fh_wcsncmp PROTO :DWORD,:DWORD,:DWORD
fh_wcsncpy PROTO :DWORD,:DWORD,:DWORD
fh_wcspbrk PROTO :DWORD,:DWORD
fh_wcsrchr PROTO :DWORD,:DWORD
fh_wcsspn PROTO :DWORD,:DWORD
fh_wcsstr PROTO :DWORD,:DWORD
fh_wcstod PROTO :DWORD,:DWORD
fh_wcstok PROTO :DWORD,:DWORD
fh_wcstol PROTO :DWORD,:DWORD,:DWORD
fh_wcstombs PROTO :DWORD,:DWORD,:DWORD
fh_wcstoul PROTO :DWORD,:DWORD,:DWORD
fh_wcsxfrm PROTO :DWORD,:DWORD,:DWORD
fh_wctomb PROTO :DWORD,:WORD

  ; ===========================================================
  ; Each of the following (to implement STDCALL) takes 6 params
  ; if you wanna pass less than 6, pass zero
  ; for the other values (or the invoke call will fail)
  ; if you wanna pass more than 6 (or pass 0 as one of the args), 
  ; you'll have to call the original version by extrning it 
  ; and handling the push and pops yourself
  ; ==========================================================
  
fh_fprintf PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fh_fwprintf PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fh_printf PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fh_wprintf PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fh_sprintf PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fh_swprintf PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fh_fscanf PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fh_fwscanf PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fh_scanf PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fh_wscanf PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fh_sscanf PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
fh_swscanf PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

  ; ============================================================
  ; Each of the following take a 'va_list' pointer as the last param.
  ; This is just a buffer that holds args one after another.
  ; ex: if the string is "yo %i %i %s" and the args are 6,5,strptr
  ; then va_list = [6][5][strptr] where [] is a dword.
  ; You would just pass the address of this buffer
  ; ============================================================
  
fh_vfprintf PROTO :DWORD,:DWORD,:DWORD
fh_vfwprintf PROTO :DWORD,:DWORD,:DWORD
fh_vprintf PROTO :DWORD,:DWORD
fh_vwprintf PROTO :DWORD,:DWORD
fh_vsprintf PROTO :DWORD,:DWORD,:DWORD
fh_vswprintf PROTO :DWORD,:DWORD,:DWORD

includelib fhcrt.lib