
;***************************************************************************************************
;Author:	FallenHobbit
;Purpose:	Demonstrates how to trap and ignore common memory access exceptions (read bad pointers)
;Date:		01/27/05
;***************************************************************************************************

.586
.model flat,stdcall
option casemap:none
include fhcrt.inc		;this is my wrapper for the c++ runtime....you can get it at my website "http://students.csci.unt.edu/~jcb0075"

ASSUME FS: nothing	;must do this in order to change FS

.DATA
mssg	DB		13,10,13,10,13,10,13,10,".....LET THE EXCEPTION HANDLER COUNTDOWN COMMENCE.....",13,10,13,10,13,10,13,10,0
prtf	DB		" %i",0
buff	DB		20 DUP(0)
retspot	DWORD	0
i		DWORD	10
sk		DB		13,10,13,10,13,10,13,10,":::COCKS HIS 9MM:::",13,10,13,10,"Yeah script kiddies. Come get some........",13,10,0

.CODE
start:

main PROC
		invoke	fh_puts,OFFSET FLAT:mssg	;show our banner message
        push	OFFSET FLAT:_except_handler	;building our new EXCEPTION_REGISTRATION_RECORD and pointing our TIB to it
        push	fs:[0]						
        mov		fs:[0],esp									
        mov		retspot,rettoo				;rettoo will be our return address for the exception handler 
_for:	sub		[i],1						;decrementing loop counter
        xor		ebx,ebx							
        mov		bl,10
        mov		[eax],ebx					;causing an exception (in this case, an invalid memory reference)
rettoo:	cmp		[i],0						;checking to see if we should loop again
		jne		_for
		invoke	fh_puts,OFFSET FLAT:sk		;just for fun....I dunno why....Im weird
        mov		eax,[esp]				;you should always do this or the exception handling will fail
        mov		fs:[0], eax
        add		esp, 8					;clean up the stack
        xor		eax,eax					;kinda pointless but Im doing it for stylistic conformity  
    	ret
main ENDP

_except_handler PROC
		invoke	fh_itoa,[i],OFFSET FLAT:buff,10
		invoke	fh_puts,eax
		push	retspot		;why am I doing this? Because the top of the stack will be popped into EIP behind our back 
		xor		eax,eax		;so this is a dirty hack to continue one instruction past the bad instruction>=0)
    	ret					;returning zero tells windows to try and ignore the exception
_except_handler ENDP

END start




